/**
 * @file register.cpp
 * @author Keith Holman
 * @date Created: Tuesday, October 14, 2008
 *
 * @brief Registers the atomic models with the simulator
 */

/* for SingleModelAdm & NewAtomicFunction */
#include "modeladm.h"
#include "mainsimu.h"

#include "engager.h"
#include "queue.h"
#include "planner.h"
#include "motor.h"
#include "translator.h"
#include "NXT++.h"

bool MainSimulator::InitializeHardware()
{
  NXT::Open();
  return true;
}

bool MainSimulator::CloseHardware()
{
  // Close the connection to the LEGO robot
  NXT::Close(); //close the NXT
  return true;
}

void MainSimulator::registerNewAtomics()
{
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Engager>(), "Engager" );
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<MyQueue>(), "MyQueue" );
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Planner>(), "Planner" );
	SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Motor>(), "Motor" );
  SingleModelAdm::Instance().registerAtomic( NewAtomicFunction<Translator>(), "Translator" );

/*
    touchvalue = false; //reset touch sensor value
    sonarvalue = 0 ;//resrt sonar sensor value
  //Tell the sonar sensor to continuously send pulses.
  NXT::Sensor::SetSonarContinuousInterval(IN_4,5000);
*/
}
