/*******************************************************************
*
*  DESCRIPTION: class AtomicData
*
*  AUTHOR: Ezequiel Glinsky
*
*  EMAIL: mailto://eglinsky@dc.uba.ar
*
*  DATE: 11/2001
*
*******************************************************************/

/** include files **/
#include "strutil.h"
#include "atomdata.h"        // header
#include "model.h"          // class Model
#include "mainsimu.h"
#include "atomic.h"      // class Atomic

/** public data **/
const ProcId AtomicData::InvalidId( -1 ) ;

/** public functions **/
/*******************************************************************
* Function Name: Constructor
********************************************************************/
AtomicData::AtomicData( Atomic *atomic )
  //: lastMsgTime( Time::Zero )
  : mdl( atomic )
  //,modelstate(NULL)
  , ident( atomic->id() ) 

{
  MASSERT( atomic );
  //MASSERT( atomic->isAtomic() );

//  cerr << " Creating new atomic " ;

  //modelstate =  (AtomicState*) atomic->allocateState();

}

/*******************************************************************
* Function Name: Destructor
********************************************************************/
AtomicData::~AtomicData()
{

}

/*******************************************************************
* Function Name: id
********************************************************************/
AtomicData &AtomicData::id( const ProcId &id )
{
  //DEVS processor Id
  ident = id ;

  return *this ;
}

/*******************************************************************
* Function Name: description
********************************************************************/
const std::string 
  AtomicData::description() const
{
  return mdl->description();
}

/*******************************************************************
* Function Name: debug
********************************************************************/
AtomicData &AtomicData::debug() {

  std::cerr << "Desc: " << mdl->description() << " model ID: " 
            << mdl->id() << " ID: " << id() << " last: " 
            << lastChange() << ", next: " << nextChange() 
            << ", externalMsgs: " << externalMsgs.asString() << std::endl;

  return *this;
}
