/*******************************************************************
*
*  DESCRIPTION: just for debuggin purposes 
*
*  AUTHOR: Amir Barylko & Jorge Beyoglonian 
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*
*  DATE: 27/6/1998
*
*******************************************************************/

#ifndef __DEBUG_H
#define __DEBUG_H

/** include files **/
#include <iostream>
#include <list>
#include "tdcell.h"

/** foward declarations **/

/** declarations **/

class NeighborhoodValue ;
class Port ;
class AtomicCell ;
class CellState ;

void PrintInfluences( const Port & );
void PrintNeighbors( NeighborhoodValue & ) ;
void PrintCellState( CellState & ) ;

/** inline **/
template <class X, class Y>
inline
std::ostream &operator <<( std::ostream& os, std::pair<X,Y> &p )
{
  os << p.first << "/" << p.second;
  return os;
}

template <typename T>
inline
std::ostream &operator<<( std::ostream &os, std::list<T> t )
{
  typename std::list<T>::iterator cursor;
  for( cursor = t.begin(); 
       cursor != t.end(); 
       os << *cursor++ << std::endl );
  return os;
}

inline
void PrintList( const TransportDelayCell::Queue &q )
{
  std::cout << q;
}

extern int getDebugLevel();
extern void setDebugLevel(int);

#define DBG(EX) if( getDebugLevel() > 0 ) { \
	std::cout << "DBG: " << __FILE__ << "(" << __LINE__ << ") " << EX << std::endl; }

#define DBGL(level,EX) if( getDebugLevel() >= level ) { \
	std::cout << "DBG: " << __FILE__ << "(" << __LINE__ << ")" << EX << std::endl; }

#endif // __DEBUG_H
