/*******************************************************************
*
*  DESCRIPTION: class FlatDEVSCoordinatorState
*
*  AUTHOR: Ezequiel Glinsky
*
*  EMAIL: mailto://eglinsky@dc.uba.ar
*
*  DATE: 11/2001
*
*******************************************************************/

#include <flatdcst.h>

/*******************************************************************
* Function Name: constructor
********************************************************************/
FlatDEVSCoordinatorState::FlatDEVSCoordinatorState():dependants(NULL) {
}

/*******************************************************************
* Function Name: destructor
********************************************************************/
FlatDEVSCoordinatorState::~FlatDEVSCoordinatorState() {
	
	if( dependants )
		delete dependants;
}


/*******************************************************************
* Function Name: operator =
********************************************************************/
FlatDEVSCoordinatorState& 
FlatDEVSCoordinatorState::operator=(FlatDEVSCoordinatorState& thisState) {
	
	(ParallelProcessorState &)*this  = (ParallelProcessorState &) thisState;
	
	//Precondition (this will always be done by allocateState)
	//slaveList is not NULL
	*(this->dependants) = *thisState.dependants;
	
	return *this;	
}

/*******************************************************************
* Function Name: copyState
********************************************************************/
void 
FlatDEVSCoordinatorState::copyState(BasicState *rhs) {
	*this = *((FlatDEVSCoordinatorState *) rhs);
}

/*******************************************************************
* Function Name: getSize
********************************************************************/
int  
FlatDEVSCoordinatorState::getSize() const {
	return sizeof(FlatDEVSCoordinatorState);
}
