#include "revsimulator.h"
#include "revatomic.h"
#include "message.h"
#include "msgadm.h"
#include "mainsimu.h"

RevSimulator::RevSimulator(RevAtomic *revatomic)
  :Processor(revatomic)
{}

Processor &RevSimulator::receive(const InitMessage &msg)
{
  RevAtomic &revat(static_cast<RevAtomic &>(model()));
  nextChange(Time::Inf);
  revat.InitFunction();
  std::cout<<"the absolute next is "<<absoluteNext()<<std::endl;
  DoneMessage done(msg.time(), Processor::id(), nextChange());
  FlatDebug().Active()?SingleMsgAdm::Instance().send(done, msg.procId()):
                       SingleMsgAdm::Instance().send(done, revat.parentId());
  lastChange(msg.time());
  return *this;
}


Processor &RevSimulator::receive(const InternalMessage &msg)
{
  std::cout<<"(RevSimulator) receive an internal message, msg value is "<<msg.value()<<" "<<msg.time()<<std::endl;
 std::cout<<"last change is "<<lastChange()<<"absolute next is "<<absoluteNext()<<std::endl;
  MASSERT( (msg.time() >= lastChange()) && (msg.time() <= absoluteNext()) );
  int value = (int)msg.value();
  if (value != 0)
{
  
  RevAtomic &revat(static_cast<RevAtomic &>(model()));
  std::cout<<"(RevSimulator) process internal message "<<model().description()<<std::endl;
  nextChange(Time::Inf);
 std::cout<<"calling internal function of models "<<revat.asString()<<std::endl;
  revat.internalFunction(msg);
  std::cout<<"calling internal function of models "<<std::endl;
  lastChange(msg.time());
  DoneMessage done(msg.time(), this->Processor::id(), nextChange());
  FlatDebug().Active()?SingleMsgAdm::Instance().send(done, msg.procId()):
                       SingleMsgAdm::Instance().send(done, revat.parentId());
 std::cout<<"(RevSimulator)end of internal message processing "<<std::endl;
}

  return *this;
}

Processor &RevSimulator::receive(const StartMessage &msg)
{
  RevAtomic &revat(static_cast<RevAtomic &>(model()));
  nextChange(Time::Inf);
  revat.StartFunction();
  DoneMessage done(msg.time(), Processor::id(), nextChange());
  FlatDebug().Active()?SingleMsgAdm::Instance().send(done, msg.procId()):
                       SingleMsgAdm::Instance().send(done, revat.parentId());

  return *this;
}

Processor &RevSimulator::id( const ProcId &pid )
{
  this->Processor::id( pid );
  MASSERT(pmodel());
  pmodel()->id( pid );
  return *this;
}
