/*******************************************************************
*
*  DESCRIPTION: CLASS StandAloneLoader
*
*  AUTHOR:    Amir Barylko & Jorge Beyoglonian 
*  Version 2: Daniel A. Rodriguez
*  Version 3: Mohammad Moallemi
*
*  EMAIL: mailto://amir@dc.uba.ar
*         mailto://jbeyoglo@dc.uba.ar
*         mailto://drodrigu@dc.uba.ar
*         mailto://moallemi@sce.carleton.ca
*
*  DATE: 27/6/1998
*  DATE: 11/4/1999 (v2)
*  DATE: 10/9/2008 (v3)
*
*******************************************************************/

#ifndef __STDALOAD_H
#define __STDALOAD_H

/** include files **/
#include "loader.h"
#include "macroexp.h"

/** declarations **/

class StandAloneLoader : public SimLoader
{
public:
	StandAloneLoader(int argc, const char *argv[]);
	~StandAloneLoader();	 //Destructor
        bool isFlatDEVS() const { return isFlatDevs;}
        const bool showWallClockTime() const; 
        SimLoader &showWallClockTime(bool);  
        const bool isRealTimeRun() const; 
        SimLoader &isRealTimeRun(bool);
        const bool isRealHardRun() const; //v3- real hardware sim
	SimLoader &isRealHardRun(bool);  //v3
	const bool EmptyEventFile() const; //v3
	SimLoader &EmptyEventFile(bool);  //v3- 

protected:
	SimLoader &loadData();
	SimLoader &writeResults();

private:
	std::string	iniName;
	std::string	outName;
	std::string	logName;
	std::string	evName;
	std::string	evalDebugName;
	std::string	flatDebugName;
	std::string	devsMdlDebugName;
	std::string	parserFileName;
	int	preprocessor;	// if is 0 then bypass the preprocessor
	bool	isFlatDevs;
	bool	isrealtimerun_m;
	bool	realsimulation_m;	//v3- test for the real case
	bool	realevents_m;		//v3
	bool	showwallclocktime_m;
};	// class StandAloneLoader

#endif   //__STDALOAD_H 
